What version of Varnish is best for my Magento site?

Which version of Varnish should I use for Magento 1 vs Magento 2?